



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL定时器开启、调用实现代码</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL定时器开启、调用实现代码</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 08:26:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>创建测试表&nbsp;</strong></p>
<div>
<pre class="prettyprint linenums">CREATE TABLE t<br />
(<br />
v VARCHAR(100) NOT NULL<br />
) ENGINE INNODB DEFAULT CHARSET=utf8; </pre>
</div>
<p><strong>创建定时器 调用的存储过程&nbsp;</strong></p>
<div>
<pre class="prettyprint linenums">DELIMITER $$<br />
DROP PROCEDURE IF EXISTS e_test $$<br />
CREATE PROCEDURE e_test()<br />
BEGIN<br />
INSERT INTO t VALUES('');<br />
END $$<br />
DELIMITER ; </pre>
</div>
<p><strong>要使定时起作用 MySQL的常量GLOBAL event_scheduler必须为on或者是1&nbsp;</strong></p>
<div>
<pre class="prettyprint linenums">-- 查看是否开启定时器<br />
SHOW VARIABLES LIKE '%sche%';<br />
-- 开启定时器 0：off 1：on<br />
SET GLOBAL event_scheduler = 1;<br />
-- 创建事件<br />
--每隔一秒自动调用e_test()存储过程<br />
CREATE EVENT IF NOT EXISTS event_test<br />
ON SCHEDULE EVERY 1 SECOND<br />
ON COMPLETION PRESERVE<br />
DO CALL e_test();<br />
-- 开启事件<br />
ALTER EVENT event_test ON<br />
COMPLETION PRESERVE ENABLE;<br />
-- 关闭事件<br />
ALTER EVENT event_test ON<br />
COMPLETION PRESERVE DISABLE; </pre>
</div>
<p><strong>从现在开始每隔九天定时执行&nbsp;</strong></p>
<div>
<pre class="prettyprint linenums">CREATE EVENT EVENT1<br />
ON SCHEDULE EVERY 9 DAY STARTS NOW()<br />
ON COMPLETION PRESERVE ENABLE<br />
DO<br />
BEGIN<br />
CALL TOTAL();<br />
END </pre>
</div>
<p><strong>每个月的一号凌晨1 点执行&nbsp;</strong></p>
<div>
<pre class="prettyprint linenums">CREATE EVENT EVENT2<br />
ON SCHEDULE EVERY 1 MONTH STARTS DATE_ADD(DATE_ADD(DATE_SUB(CURDATE(),INTERVAL DAY(CURDATE())-1 DAY), INTERVAL 1 MONTH),INTERVAL 1 HOUR)<br />
ON COMPLETION PRESERVE ENABLE<br />
DO<br />
BEGIN<br />
CALL STAT();<br />
END </pre>
</div>
<p><strong>每个季度一号的凌晨2点执行&nbsp;</strong></p>
<div>
<pre class="prettyprint linenums">CREATE EVENT TOTAL_SEASON_EVENT<br />
ON SCHEDULE EVERY 1 QUARTER STARTS DATE_ADD(DATE_ADD(DATE( CONCAT(YEAR(CURDATE()),'-',ELT(QUARTER(CURDATE()),1,4,7,10),'-',1)),INTERVAL 1 QUARTER),INTERVAL 2 HOUR)<br />
ON COMPLETION PRESERVE ENABLE<br />
DO<br />
BEGIN<br />
CALL SEASON_STAT();<br />
END </pre>
</div>
<p><strong>每年1月1号凌晨四点执行&nbsp;</strong></p>
<div>
<pre class="prettyprint linenums">CREATE EVENT TOTAL_YEAR_EVENT<br />
ON SCHEDULE EVERY 1 YEAR STARTS DATE_ADD(DATE(CONCAT(YEAR(CURDATE()) + 1,'-',1,'-',1)),INTERVAL 4 HOUR)<br />
ON COMPLETION PRESERVE ENABLE<br />
DO<br />
BEGIN<br />
CALL YEAR_STAT();<br />
END </pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdj120q.html">嵌入式Linux驱动学习之路&lpar;十一&rpar;按键驱动-中断机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ol7me8.html">Tomcat系统部署启动问题分析一例&lbrack;sudo 启动&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7xll9.html">nginx  json 格式输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/r931rgz8.html">借助Glances Monitor，密切关注你的系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v7md48.html">nyist 597 完数？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydjlojq.html">Android源代码分析之Framework的MediaPlayer</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzzpzg8.html">CKEditor上传插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4r6nq.html">python object takes no parameters</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj65338.html">2017-2018-1 Java演绎法 第三周 作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y4pmg8.html">重构：以Java POI 导出EXCEL为例2</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1jr0lq.html">web 文件上传的几种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2dkex9.html">WorldCount代码检查与优化&mdash;&mdash;软件测试第三次作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2jp719.html">如何在Python中使用ZeroMQ和Docker构建微服务架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2wd1j9.html">在最新的Power BI Desktop中使用报表主题功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwyk5j9.html">第 4 章 容器 - 028 - 限制容器对CPU的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2l2719.html">Dll重定向（尚存否？）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26r7x9.html">vue router 跳转到新的窗口方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn1w7mq.html">Struts2拦截器的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pplvz49.html">如何理解IPD&plus;CMMI&plus;Scrum一体化研发管理解决方案之IPD篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdv4poq.html">VMware Workstation 12 Pro（安装CentOS7）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pvevd9.html">Windows 常用 CMD 命令行介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jxrp0q.html">IT菜鸟的第2天（输入输出，数据类型，运算符的使用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kdz4r9.html">centos7 安装拼音输入法（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx4mnz9.html">fabric批量操作远程操作主机的练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx4myv9.html">iOS原生项目中集成React Native</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnlxrk9.html">使用ViewBag传送数据从控制器至视图</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyokjx8.html">git 找回丢失的commit</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnloo29.html">Linux 网络编程详解二（socket创建流程、多进程版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8exzrxq.html">oracle&colon; job使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7471q.html">java调用&period;net asmx &sol; wcf</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
